#ifndef atol_interface_h__included
#define atol_interface_h__included

// ATOL (C) 2005, Alexander G. Karpov [mrhx]
// Version 0.7
// http://mrhx.narod.ru/
// (!)    ATOL   .
// (!)        ATOL.

#include <windows.h>

typedef void * ATOL_ATOM;					// ATOM TYPE.
typedef char * ATOL_STRING;					// STRING TYPE.
typedef void * ATOL_LIST;					// LIST TYPE.

typedef struct ATOL_INTERFACE_S
{
	ATOL_STRING (WINAPI * version)();					 // Get version string.
	ATOL_STRING (WINAPI * copyright)();					 // Get copyright string.

	ATOL_ATOM (WINAPI * atom)(ATOL_STRING name);		 // Add an atom or get existing one.
	ATOL_STRING (WINAPI * atom_name)(ATOL_ATOM atom);	 // Get atom name.

	ATOL_STRING (WINAPI * list_item)(ATOL_LIST list);	 // Get list item.
	ATOL_ATOM (WINAPI * list_item_atom)(ATOL_LIST list); // Get list item as atom.
	ATOL_LIST (WINAPI * list_next)(ATOL_LIST list);		 // Get next list element.

	void (__cdecl * printf)(ATOL_STRING msg, ...);		 // Write a formatted string to console.
	void (WINAPI * print)(ATOL_STRING msg);				 // Write a string to console.
	void (WINAPI * puts)(ATOL_STRING msg);				 // Write a string to console and end line.

	int (WINAPI * getc)();								 // Read a character from console.
	int (WINAPI * gets)(ATOL_STRING buf, int maxnum);	 // Read a string from console.

	int (WINAPI * atoi)(ATOL_STRING str);				 // Convert string to integer.

} *ATOL_INTERFACE;


#endif // atol_interface_h__included
